# Tili-Toli (15-ös játék)
# A számok összekeverése [SPACE] billentyűvel történik.
# A számok mozgatása a kurzormozgató billenyűkkel (fel, le, jobbra, balra) 

import turtle
import random
turtle.hideturtle()
screen = turtle.Screen()
screen.setup(450,450)
screen.bgcolor("darkblue")
screen.title("S T A R T --->> SPACE")
turtle.speed(0)
turtle.tracer(0)

szamok = [turtle.Turtle() for i in range(15)]

for i in range(1,16):
    screen.addshape(str(i) + ".gif")

for index, szam in enumerate(szamok):
    szam.hideturtle()
    szam.shape(str(index + 1) + ".gif")

foglalt = [[0]*6 for i in range(6)]
           
for i, szam in enumerate(szamok):
    foglalt[i // 4 + 1][i % 4 +1] = i + 1
    szam.up()

foglalt[4][4] = 16
x, y = 4, 4

for i, szam in enumerate(szamok):
    szam.setposition(i % 4 * 100-150, 150 - i // 4 * 100)
    szam.showturtle()    

turtle.update()

def fel():
    global x, y, szamok
    z = -1
    if foglalt[x + 1][y] > 0:
        z = foglalt[x + 1][y] - 1
        foglalt[x][y] = foglalt[x + 1][y]
        foglalt[x + 1][y] = 16
        x = x + 1       
        szamok[z].sety(szamok[z].ycor() + 100)
        turtle.update()
def le():
    global x, y
    z = -1
    if foglalt[x - 1][y] > 0:
        z = foglalt[x - 1][y] - 1
        foglalt[x][y] = foglalt[x - 1][y]
        foglalt[x - 1][y] = 16
        x = x - 1
        szamok[z].sety(szamok[z].ycor() - 100)
        turtle.update()
def bal():
    global x, y
    z = -1
    if foglalt[x][y + 1] > 0:
        z = foglalt[x][y + 1] - 1
        foglalt[x][y] = foglalt[x][y + 1]
        foglalt[x][y + 1] = 16
        y = y + 1              
        szamok[z].setx(szamok[z].xcor() - 100)
        turtle.update()
def jobb():
    global x, y
    z = -1
    if foglalt[x][y - 1] > 0:
        z = foglalt[x][y - 1] - 1
        foglalt[x][y] = foglalt[x][y - 1]
        foglalt[x][y - 1] = 16
        y = y - 1                  
        szamok[z].setx(szamok[z].xcor() + 100)
        turtle.update()
def kever():
    global x, y
    for i in range(500):
        vel = random.randint(1,4)
        if vel==1 and x != 1:
            bal()
        if vel==2 and y != 1:
            le()
        if vel==3 and x != 4:
            jobb()
        if vel==4 and y != 4:
            fel()
        turtle.update()

screen.onkey(fel, "Up")
screen.onkey(le, "Down")
screen.onkey(bal, "Left")
screen.onkey(jobb, "Right")
screen.onkey(kever, " ")
screen.listen()
turtle.exitonclick()

# ************2023.02.11.************Miskei Vendel************www.miskei.hu************